Index: protocols/skype/skype.c
===================================================================
--- protocols/skype/skype.c	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/skype.c	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -118,4 +118,6 @@
 	 * created. */
 	char *pending_user;
+	/* If the info command was used, to determine what to do with FULLNAME result. */
+	int is_info;
 };
 
@@ -320,6 +322,8 @@
 
 	nicks = g_strsplit(line + 6, ", ", 0);
-	for (i = nicks; *i; i++)
+	for (i = nicks; *i; i++) {
 		skype_printf(ic, "GET USER %s ONLINESTATUS\n", *i);
+		skype_printf(ic, "GET USER %s FULLNAME\n", *i);
+	}
 	g_strfreev(nicks);
 }
@@ -375,7 +379,15 @@
 		if (set_getbool(&ic->acc->set, "show_moods"))
 			imcb_log(ic, "User `%s' changed mood text to `%s'", user, buf);
-	} else if (!strncmp(ptr, "FULLNAME ", 9))
-		sd->info_fullname = g_strdup(ptr + 9);
-	else if (!strncmp(ptr, "PHONE_HOME ", 11))
+	} else if (!strncmp(ptr, "FULLNAME ", 9)) {
+		char *name = ptr + 9;
+		if (sd->is_info) {
+			sd->is_info = FALSE;
+			sd->info_fullname = g_strdup(name);
+		} else {
+			char *buf = g_strdup_printf("%s@skype.com", user);
+			imcb_rename_buddy(ic, buf, name);
+			g_free(buf);
+		}
+	} else if (!strncmp(ptr, "PHONE_HOME ", 11))
 		sd->info_phonehome = g_strdup(ptr + 11);
 	else if (!strncmp(ptr, "PHONE_OFFICE ", 13))
@@ -1503,4 +1515,5 @@
 static void skype_get_info(struct im_connection *ic, char *who)
 {
+	struct skype_data *sd = ic->proto_data;
 	char *ptr, *nick;
 	nick = g_strdup(who);
@@ -1508,4 +1521,5 @@
 	if (ptr)
 		*ptr = '\0';
+	sd->is_info = TRUE;
 	skype_printf(ic, "GET USER %s FULLNAME\n", nick);
 	skype_printf(ic, "GET USER %s PHONE_HOME\n", nick);
Index: protocols/skype/t/add-yes-skyped.mock
===================================================================
--- protocols/skype/t/add-yes-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/add-yes-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -9,4 +9,6 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS ONLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 >> SET USER bob BUDDYSTATUS 2 Please authorize me
 << USER bob BUDDYSTATUS 2
Index: protocols/skype/t/added-no-skyped.mock
===================================================================
--- protocols/skype/t/added-no-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/added-no-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -9,4 +9,6 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS ONLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 << USER bob RECEIVEDAUTHREQUEST Please allow me to see when you are online
 >> SET USER bob ISAUTHORIZED FALSE
Index: protocols/skype/t/added-yes-skyped.mock
===================================================================
--- protocols/skype/t/added-yes-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/added-yes-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -9,4 +9,6 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS ONLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 << USER bob RECEIVEDAUTHREQUEST Please allow me to see when you are online
 >> SET USER bob ISAUTHORIZED TRUE
Index: protocols/skype/t/call-failed-skyped.mock
===================================================================
--- protocols/skype/t/call-failed-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/call-failed-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -9,6 +9,10 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS ONLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 >> GET USER bob ONLINESTATUS
 << USER bob ONLINESTATUS OFFLINE
+>> GET USER bob FULLNAME
+<< USER bob FULLNAME Bob
 >> CALL bob
 << CALL 216 STATUS UNPLACED
Index: protocols/skype/t/call-skyped.mock
===================================================================
--- protocols/skype/t/call-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/call-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -9,6 +9,10 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS OFFLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 >> GET USER bob ONLINESTATUS
 << USER bob ONLINESTATUS ONLINE
+>> GET USER bob FULLNAME
+<< USER bob FULLNAME Bob
 >> CALL bob
 << CALL 178 STATUS UNPLACED
Index: protocols/skype/t/called-no-skyped.mock
===================================================================
--- protocols/skype/t/called-no-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/called-no-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -9,6 +9,10 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS ONLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 >> GET USER bob ONLINESTATUS
 << USER bob ONLINESTATUS ONLINE
+>> GET USER bob FULLNAME
+<< USER bob FULLNAME Bob
 << CALL 212 CONF_ID 0
 << CALL 212 STATUS RINGING
Index: protocols/skype/t/called-yes-skyped.mock
===================================================================
--- protocols/skype/t/called-yes-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/called-yes-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -9,6 +9,10 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS ONLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 >> GET USER bob ONLINESTATUS
 << USER bob ONLINESTATUS ONLINE
+>> GET USER bob FULLNAME
+<< USER bob FULLNAME Bob
 << CALL 208 CONF_ID 0
 << CALL 208 STATUS RINGING
Index: protocols/skype/t/ctcp-help-skyped.mock
===================================================================
--- protocols/skype/t/ctcp-help-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/ctcp-help-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -9,4 +9,8 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS ONLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 >> GET USER bob ONLINESTATUS
 << USER bob ONLINESTATUS ONLINE
+>> GET USER bob FULLNAME
+<< USER bob FULLNAME Bob
Index: protocols/skype/t/filetransfer-skyped.mock
===================================================================
--- protocols/skype/t/filetransfer-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/filetransfer-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -9,6 +9,10 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS ONLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 >> GET USER bob ONLINESTATUS
 << USER bob ONLINESTATUS ONLINE
+>> GET USER bob FULLNAME
+<< USER bob FULLNAME Bob
 << FILETRANSFER 208 TYPE INCOMING
 << FILETRANSFER 208 PARTNER_HANDLE bob
Index: protocols/skype/t/group-read-skyped.mock
===================================================================
--- protocols/skype/t/group-read-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/group-read-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -17,10 +17,20 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS ONLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 >> GET USER bob ONLINESTATUS
 << USER bob ONLINESTATUS ONLINE
+>> GET USER bob FULLNAME
+<< USER bob FULLNAME Bob
 >> GET USER cecil ONLINESTATUS
 << USER cecil ONLINESTATUS ONLINE
+>> GET USER cecil FULLNAME
+<< USER cecil FULLNAME Cecil
 >> GET USER daniel ONLINESTATUS
 << USER daniel ONLINESTATUS ONLINE
+>> GET USER daniel FULLNAME
+<< USER daniel FULLNAME Daniel
 >> GET USER emily ONLINESTATUS
 << USER emily ONLINESTATUS OFFLINE
+>> GET USER emily FULLNAME
+<< USER emily FULLNAME Emily
Index: protocols/skype/t/groupchat-invite-bitlbee.mock
===================================================================
--- protocols/skype/t/groupchat-invite-bitlbee.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/groupchat-invite-bitlbee.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -5,4 +5,5 @@
 << PRIVMSG &bitlbee :account add skype alice foo
 << PRIVMSG &bitlbee :account skype on
+>> :bob!bob@skype.com JOIN :&bitlbee
 << PRIVMSG &bitlbee :chat with bob
 >> 353 alice = ##alice/$bob;a7ab206ec780 :@alice bob @root
Index: protocols/skype/t/groupchat-invite-skyped.mock
===================================================================
--- protocols/skype/t/groupchat-invite-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/groupchat-invite-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -9,8 +9,14 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS ONLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 >> GET USER bob ONLINESTATUS
 << USER bob ONLINESTATUS ONLINE
+>> GET USER bob FULLNAME
+<< USER bob FULLNAME Bob
 >> GET USER cecil ONLINESTATUS
 << USER cecil ONLINESTATUS ONLINE
+>> GET USER cecil FULLNAME
+<< USER cecil FULLNAME Cecil
 >> CHAT CREATE bob
 << CHAT #alice/$bob;a7ab206ec78060f1 STATUS DIALOG
Index: protocols/skype/t/groupchat-invited-skyped.mock
===================================================================
--- protocols/skype/t/groupchat-invited-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/groupchat-invited-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -9,8 +9,14 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS ONLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 >> GET USER bob ONLINESTATUS
 << USER bob ONLINESTATUS OFFLINE
+>> GET USER bob FULLNAME
+<< USER bob FULLNAME Bob
 >> GET USER cecil ONLINESTATUS
 << USER cecil ONLINESTATUS OFFLINE
+>> GET USER cecil FULLNAME
+<< USER cecil FULLNAME Cecil
 << CHAT #cecil/$bob;4d8cc9965791c6b9 NAME #cecil/$bob;4d8cc9965791c6b9
 << CHAT #cecil/$bob;4d8cc9965791c6b9 STATUS MULTI_SUBSCRIBED
Index: protocols/skype/t/info-skyped.mock
===================================================================
--- protocols/skype/t/info-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/info-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -9,6 +9,10 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS ONLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 >> GET USER bob ONLINESTATUS
 << USER bob ONLINESTATUS ONLINE
+>> GET USER bob FULLNAME
+<< USER bob FULLNAME Bob
 >> GET USER bob FULLNAME
 << USER bob FULLNAME Bob
Index: protocols/skype/t/login-skyped.mock
===================================================================
--- protocols/skype/t/login-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/login-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -9,4 +9,8 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS ONLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 >> GET USER bob ONLINESTATUS
 << USER bob ONLINESTATUS ONLINE
+>> GET USER bob FULLNAME
+<< USER bob FULLNAME Bob
Index: protocols/skype/t/msg-skyped.mock
===================================================================
--- protocols/skype/t/msg-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/msg-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -9,6 +9,10 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS ONLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 >> GET USER bob ONLINESTATUS
 << USER bob ONLINESTATUS ONLINE
+>> GET USER bob FULLNAME
+<< USER bob FULLNAME Bob
 >> MESSAGE bob foo
 << CHATMESSAGE 290 STATUS SENDING
Index: protocols/skype/t/set-mood-text-skyped.mock
===================================================================
--- protocols/skype/t/set-mood-text-skyped.mock	(revision c440320f9df04f05ead97bc7a7a016e23e49bb64)
+++ protocols/skype/t/set-mood-text-skyped.mock	(revision ed3ff435ac2caf34de6b67ae4b6b3f8a04c7ebb7)
@@ -9,4 +9,6 @@
 >> GET USER echo123 ONLINESTATUS
 << USER echo123 ONLINESTATUS ONLINE
+>> GET USER echo123 FULLNAME
+<< USER echo123 FULLNAME Echo / Sound Test Service
 >> SET PROFILE MOOD_TEXT foo bar
 << PROFILE MOOD_TEXT foo bar
